package inf1010.pusle.adventure;

/**
 * A tiny enum used to place equipment on different body parts.
 *
 * This could also be used to build a more advanced battle system
 * (critical hits on body parts).
 */
enum BodyPart {

    HANDS("hands"), TORSO("torso"), HEAD("head");

    /** The text describing the body part. */
    String text;

    /**
     * Creates a new BodyPart with the associated text.
     *
     * @param text The text describing the body part.
     */
    private BodyPart(String text) {
	this.text = text;
    }

    /**
     * Looks for a body part matching the text.
     *
     * @param The text of the body part to look for.
     * @return The body part with the given text or null if there's no match.
     */
    public static BodyPart getBodyPart(String text) {
	for (BodyPart bp : values()) {
	    if (bp.text.equals(text)) {
		return bp;
	    }
	}

	return null;
    }

}