package inf1010.pusle.adventure;

class Item extends Entity implements Comparable<Item> {

    /** The name of the item. Used to identify it in-game. */
    final String name;

    /**
     * Creates a new Item.
     */
    public Item(String name, String desc) {
	super(desc);
	this.name = name;
    }
	
    /**
     * Used to choose between a and an in sentences.
     */
    public boolean startsWithVowel() {
	switch(name.charAt(0)) {
	case 'a': case 'A':
	case 'e': case 'E':
	case 'i': case 'I':
	case 'o': case 'O':
	case 'u': case 'U':
	    return true;
	}
	return false;
    }
	
    /**
     * Compares two items' names.
     *
     * @return 0 if the names are the same,
     *		   a negative number if it is lexically lower
     * 		   and a positive number if it is lexically higher.
     */
    public int compareTo(Item it) {
	if (it == null)
	    return -1;

	return name.compareTo(it.name);
    }
}