package inf1010.pusle.adventure;

/**
 * Represents rooms in the game.
 */
class Room extends Entity {

    /** The room's ID. */
    final int id;
	
    /** Items lying on the ground. */
    SinglyLinkedList<Item> items = new SinglyLinkedList<Item>();
	
    /** Non-Player Characters in this room. */
    SinglyLinkedList<Character> npcs = new SinglyLinkedList<Character>();

    // TODO
    // Add something to represent connections to other rooms
	
    /**
     * Creates a room with the given id and description.
     *
     * @param desc The room's desciption.
     * @param id The room's id, this must be unique.
     */
    public Room(String desc, int id) {
	super(desc);
	this.id = id;
    }
	
    /**
     * Prints a description of this room and a list of what's in the room.
     */
    public void printDescription() {
	super.printDescription();
		
	if (!items.isEmpty()) {
	    for (Item it : items) {
		System.out.printf("A%s %s is lying on the ground.%n",
				  (it.startsWithVowel() ? "n" : ""),
				  it.name);
	    }
	}
		
	if (!npcs.isEmpty()) {
	    for (Character npc : npcs) {
		System.out.printf("%s is here.%n", npc.name);
	    }
	}
    }

    /**
     * Adds an exit to another room.
     * If the exit already exists,
     * this replaces the room that's linked by that exit.
     */
    public void addExit(Direction d, Room room) {
	// TODO
	// Write code to set the room that's connected to this room
	// in the given direction.
    }

    /**
     * Gets the room linked to this room in the given direction.
     *
     * @param d The direction in which the other room is linked.
     * @return The room lying in the given direction,
     *		   or null if there's no exit that way.
     */
    public Room getRoom(Direction d) {
	// TODO
	// Write code to return rooms from the links you set up between them
	return null;
    }
}